/***************************************************************************************/
/* Header zur Klasse CLinkedList      (CLinkedList.h)                                  */
/*                                                                                     */
/* Kurzbeschreibung                                                                    */
/*  Klasse fuer eine doppelt verkettete Liste (engl. linked list)                      */
/*                                                                                     */
/* Aenderungen/Ergaenzungen                                                            */
/*                                                                                     */
/* Entwickler: Buchgeher Stefan                                                        */
/* Entwicklungsbeginn dieser Klasse: 10. Oktober 2006                                  */
/* Funktionsfaehig seit: 10. Oktober 2006                                              */
/* Letzte Bearbeitung: 24. Januar 2007                                                 */
/***************************************************************************************/

#ifndef __CLinkedList
#define __CLinkedList


/****************** Include-Dateien ****************************************************/
#include "CNode.h"


/****************** Konstanten *********************************************************/
enum SCROLL_DIRECTION
{
    SCROLL_BACK,
    SCROLL_FORWARD,
    SCROLL_BEGIN,
    SCROLL_END
};


/****************** Klassendefinition **************************************************/
class CLinkedList
{
public:
    // Konstruktoren
    CLinkedList();
    CLinkedList(int nValue);

    // Kopierkonstruktor
 //   CLinkedList (const CLinkedList &rhs);


    // Destruktor
    virtual ~CLinkedList();


    // oeffentliche Member-Funktionen
    int AddNode(int nValue);

    int ShowList(void);

    int RemoveNode(void);
    int DeleteList(void);

    int Scroll(int nDirection);

    //CLinkedList::operator=( const CLinkedList &rhs);

    // ACHTUNG: noch nicht realisiert, da beim Demo keine Zuweisung zwischen zwei Listen
    // vorkommt! Ist aber bei einer Zuweisung in einer Applikation (z.B. Liste2 = Liste1)
    // absolut notwendig und muss daher geeignet realisiert werden!!!


protected:
    // geschuetzte Member-Variablen
    CNode *m_pRoot;             // Zeiger auf den ersten Knoten der Liste
    CNode *m_pEnd;              // Zeiger auf den letzten Knoten der Liste
    CNode *m_pActuell;          // Zeiger auf den aktuell "bearbeiteten" Knoten der Liste
};

#endif // __CLinkedList