/***************************************************************************************/
/* Klasse CNode       (CNode.cpp)                                                      */
/*                                                                                     */
/* Kurzbeschreibung                                                                    */
/*  Klasse fuer einen Knoten einer verketteten Liste (engl. linked list)               */
/*                                                                                     */
/* Aenderungen/Ergaenzungen                                                            */
/*                                                                                     */
/* Entwickler: Buchgeher Stefan                                                        */
/* Entwicklungsbeginn dieser Klasse: 10. Oktober 2006                                  */
/* Funktionsfaehig seit: 10. Oktober 2006                                              */
/* Letzte Bearbeitung: 24. Januar 2007                                                 */
/***************************************************************************************/

/****************** Include-Dateien ****************************************************/
#include "CNode.h"


/****************** Konstruktoren ******************************************************/

/***************************************************************************************/
/* CNode (Default-Konstruktor):                                                        */
/*                                                                                     */
/* Aufgaben:                                                                           */
/*  - Alle Member-Variablen und -Zeiger mit 0 initialisieren                           */
/*                                                                                     */
/* Veraenderte Member-Variablen:                                                       */
/*  - m_nValue                                                                         */
/*  - m_pLast                                                                          */
/*  - m_pNext                                                                          */
/***************************************************************************************/
CNode::CNode()
{
    m_nValue = 0;
    m_pLast = 0;
    m_pNext = 0;
}


/***************************************************************************************/
/* CNode(int nValue):                                                                  */
/*                                                                                     */
/* Aufgaben:                                                                           */
/*  - Die Member-Variable m_nValue mit dem uebergebenen Parameter initialisieren, und  */
/*    die Zeiger m_pLast und m_pNext mit 0 initialisieren                              */
/*                                                                                     */
/* Uebergabeparameter:                                                                 */
/*  - nValue (Die zu speichernde Zahl)                                                 */
/*                                                                                     */
/* Veraenderte Member-Variablen:                                                       */
/*  - m_nValue                                                                         */
/*  - m_pLast                                                                          */
/*  - m_pNext                                                                          */
/***************************************************************************************/
CNode::CNode(int nValue)
{
    m_nValue = nValue;
    m_pLast = 0;
    m_pNext = 0;
}


/***************************************************************************************/
/* CNode (const CNode &rhs):     (Kopierkonstruktor)                                   */
/*                                                                                     */
/* Aufgabe:                                                                            */
/*  - Kopierkonstruktor                                                                */
/*                                                                                     */
/* Veraenderte Member-Variablen:                                                       */
/*  keine                                                                              */
/***************************************************************************************/
CNode::CNode (const CNode &rhs)
{
    m_nValue = rhs.m_nValue;
    m_pLast = rhs.m_pLast;
    m_pNext = rhs.m_pNext;
}


/****************** Destruktor *********************************************************/

/***************************************************************************************/
/* ~CNode:                                                                             */
/*                                                                                     */
/* Aufgabe:                                                                            */
/*  Hat hier keine Aufgabe                                                             */
/*                                                                                     */
/* Veraenderte Member-Variablen:                                                       */
/*  keine                                                                              */
/***************************************************************************************/
CNode::~CNode()
{
}
