/***************************************************************************************/
/* Header zur Klasse CNode      (CNode.h)                                              */
/*                                                                                     */
/* Kurzbeschreibung                                                                    */
/*  Klasse fuer einen Knoten einer verketteten Liste (engl. linked list)               */
/*                                                                                     */
/* Aenderungen/Ergaenzungen                                                            */
/*                                                                                     */
/* Entwickler: Buchgeher Stefan                                                        */
/* Entwicklungsbeginn dieser Klasse: 10. Oktober 2006                                  */
/* Funktionsfaehig seit: 10. Oktober 2006                                              */
/* Letzte Bearbeitung: 24. Januar 2007                                                 */
/***************************************************************************************/

#ifndef __CNode
#define __CNode


/****************** Include-Dateien ****************************************************/
// keine Include-Dateien notwendig


/****************** Konstanten *********************************************************/
// keine Konstanten


/****************** Klassendefinition **************************************************/
class CNode
{
public:
    // Konstruktoren
    CNode();
    CNode(int nValue);

    // Kopierkonstruktor
    CNode (const CNode &rhs);

    // Destruktor
    virtual ~CNode();

    // oeffentliche Member-Funktionen
    void SetValue(int nValue) {m_nValue = nValue;}
    void SetLast(CNode *pLast) {m_pLast = pLast;}
    void SetNext(CNode *pNext) {m_pNext = pNext;}

    int GetValue() const {return m_nValue;}
    CNode* GetLast() const {return m_pLast;}
    CNode* GetNext() const {return m_pNext;}


protected:
    // geschuetzte Member-Variablen
    int m_nValue;               // den zu speichernden Wert
    CNode *m_pLast;             // Zeiger auf den vorhergehenden Knoten
    CNode *m_pNext;             // Zeiger auf den folgenden Knoten
};

#endif // __CNode