VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLinkedListD"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'***************************************************************************************
'* Klasse clsLinkedListD        (clsLinkedListD.cls)                                   *
'*                                                                                     *
'* Kurzbeschreibung                                                                    *
'*  Klasse fuer eine doppelt verkettete Liste (engl. linked list)                      *
'*                                                                                     *
'* Aenderungen/Ergaenzungen                                                            *
'*                                                                                     *
'* Entwickler: Buchgeher Stefan                                                        *
'* Entwicklungsbeginn dieser Klasse: 28. Februar 2007                                  *
'* Funktionsfaehig seit: 28. Februar 2007                                              *
'* Letzte Bearbeitung: 6. Maerz 2007                                                   *
'***************************************************************************************
Option Explicit


'****************** Member-Variablen ***************************************************
Private m_pRoot As clsNodeD      'Zeiger auf den ersten Knoten der Liste
Private m_pEnd As clsNodeD       'Zeiger auf den letzten Knoten der Liste
Private m_pActuell As clsNodeD   'Zeiger auf den aktuellen Knoten der Liste

 
'****************** Member-Funktionen **************************************************
'Public Function AddNode(ByVal sValue As String) As Integer
'Public Function ShowList(ListBox As Object) As Integer
'Public Function RemoveNode() As Integer
'Public Function RemoveList() As Integer


'****************** Konstruktor ********************************************************

'***************************************************************************************
'* Private Sub Class_Initialize():                                                     *
'*                                                                                     *
'* Aufgaben:                                                                           *
'*  - Die Member-Variablen mit 0 (= Nothing) initialisieren                            *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pEnd                                                                           *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Private Sub Class_Initialize()
    Set m_pRoot = Nothing
    Set m_pEnd = Nothing
    Set m_pActuell = Nothing
End Sub


'****************** Destruktor *********************************************************

'***************************************************************************************
'* Private Sub Class_Terminate():                                                      *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  Die gesamte Liste (falls vorhanden) vom Speicher entfernen.                        *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pEnd                                                                           *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Private Sub Class_Terminate()
    Dim ErrorCode As Integer
    
    
    ErrorCode = RemoveList()
End Sub


'****************** Member-Funktionen (Realisierung) ***********************************

'***************************************************************************************
'* Public Function AddNode(sValue As String) As Integer:                               *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  Neuen Knoten (mit dem String sValue) ans Ende der bestehenden Liste anhaengen.     *
'*                                                                                     *
'* Uebergabeparameter:                                                                 *
'*  sValue: Dieser Wert (String) soll in den neu hinzugefuegten Knoten gespeichert     *
'*          werden.                                                                    *
'*                                                                                     *
'* Rueckgabewert:                                                                      *
'*  - Fehlercode:   0 ... kein Fehler                                                  *
'*                  1 ... Es kann kein Knoten hinzugefuegt werden, weil kein Speicher  *
'*                        alloziiert werden kann!                                      *
'*                                                                                     *
'* Vorgehensweise:                                                                     *
'*  - Speicherplatz fuer den neuen Knoten dynamisch anfordern.                         *
'*  - Die zu speichernden Daten im neuen Knoten (pNewNode) speichern (mit Hilfe der    *
'*    Memberfunktion SetValue der Klasse clsNode)                                      *
'*  - Das Verketten der Knoten ist nun abhaengig davon, an welcher Position sich der   *
'*    neue Knoten befindet:                                                            *
'*                                                                                     *
'*      - FALL 1: Der neue Knoten (pNewNode) befindet sich am Anfang der Liste, es ist *
'*        daher auch das erste Element der Liste                                       *
'*        (Kennzeichen: m_pRoot = 0 (Nothing)                                          *
'*        Da es das erste Element der Liste ist gilt fuer diesen Knoten:               *
'*           - Der Zeiger auf den vorhergehende Knoten muss den Wert 0 (Nothing)       *
'*             beinhalten                                                              *
'*           - Der Zeiger auf das naechste Element muss ebenfalls den Wert 0 (Nothing) *
'*             beinhalten                                                              *
'*           - Die (Member-)Zeiger m_pRoot, m_pEnd und m_pActuell zeigen auf diesen    *
'*             ersten Knoten.                                                          *
'*                                                                                     *
'*      - FALL 2: Der neue Knoten (pNewNode) befindet sich am Ende der Liste,          *
'*        (Kennzeichen: m_pActuell.GetNext = 0 (Nothing)                               *
'*        Da es der letzte Knoten der Liste ist gilt fuer diesen Knoten:               *
'*           - Der Zeiger von pNewNode auf den naechsten Knoten muss den Wert 0        *
'*             (Nothing) beinhalten                                                    *
'*           - Der Zeiger von pNewNode auf den vorhergehenden Knoten muss den Zeiger   *
'*             Zeiger pActuell beinhalten                                              *
'*           - Der Zeiger von pActuell auf den naechste Knoten muss den Wert des       *
'*             Zeigers pNewNode beinhalten                                             *
'*           - Die (Member-)Zeiger m_pEnd und m_pActuell zeigen auf diesen letzten     *
'*             Knoten.                                                                 *
'*                                                                                     *
'*      - FALL 3: Der neue Knoten befindet sich nicht am Ende der Liste, sondern       *
'*        mittendrin                                                                   *
'*        Da es ein Knoten innerhalb der Liste ist gilt fuer dieses Knoten:            *
'*           - Den auf pActuell folgenden Knoten in pTemp sichern                      *
'*           - Den neuen Knoten pNewNode nun so mit pActuell und pTemp verketten, dass *
'*             es sich anschliessend zwischen pActuell und pTemp befindet              *
'*           - Verkettung zwischen pActuell und pNewNode herstellen                    *
'*           - Verkettung zwischen pNewNode und pTemp herstellen                       *
'*           - Der (Member-)Zeiger m_pActuell zeigt auf den eingefuegten Knoten        *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pEnd                                                                           *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Public Function AddNode(sValue As String) As Integer
    Dim pNewNode As clsNodeD
    
    Dim pTemp As clsNodeD       'Hilfszeiger, fuer Fall 3 notwendig
    
    
    'Knoten erzeugen
    Set pNewNode = New clsNodeD
     
    'Daten im  Knoten speichern
    pNewNode.SetValue = sValue
    
    'Verketten
    If m_pRoot Is Nothing Then
        'Fall 1: Erster Knoten der Liste
        Set pNewNode.SetNext = Nothing
        Set pNewNode.SetLast = Nothing
        Set m_pRoot = pNewNode
        Set m_pEnd = pNewNode
    Else
        If m_pActuell.GetNext Is Nothing Then
            'Fall 2: Knoten am Ende der Liste anhaengen
            
            'Die Knoten m_pActuell und pNewNode miteinander verbinden (Neuen Knoten
            'an das Ende der Liste, also an den "aktuellen" Knoten anhaengen
            Set pNewNode.SetNext = Nothing
            Set pNewNode.SetLast = m_pActuell
            
            Set m_pActuell.SetNext = pNewNode
            
            Set m_pEnd = pNewNode
        Else
            'Fall 3: Knoten irgendwo zwischen Anfang und Ende

            'Adresse des auf pActuell folgenden Knoten in pTemp zwischenspeichern
            Set pTemp = m_pActuell.GetNext
    
            'Den neuen Knoten zwischen pActuell und pTemp einfuegen (verketten)
            'pActuell <-> pNewNode
            Set m_pActuell.SetNext = pNewNode
            Set pNewNode.SetLast = m_pActuell

            'pNewNode <-> pTemp
            Set pNewNode.SetNext = pTemp
            Set pTemp.SetLast = pNewNode
        End If
    End If
    
    'Zeiger m_pActuell auf den neuen Knoten referenzieren
    Set m_pActuell = pNewNode
    
    'Rueckgabewert
    AddNode = 0     'kein Fehler
End Function
 

'***************************************************************************************
'* Public Function ShowList(ListBox As Object) As Integer:                             *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  - Die gesamte Liste in der uebergebenen List-Box anzeigen                          *
'*                                                                                     *
'* Uebergabeparameter:                                                                 *
'*  - Listbox (Objekt)                                                                 *
'*                                                                                     *
'* Rueckgabewert:                                                                      *
'*  - Fehlercode:   0 ... kein Fehler                                                  *
'*                  1 ... Es ist keine Liste vorhanden                                 *
'*                                                                                     *
'* Vorgehensweise:                                                                     *
'*  - ListBox loeschen                                                                 *
'*  - Ist die Liste leer (m_pRoot = 0) den Text "Leer!" in die Listbox schreiben und   *
'*    den entsprechenden Fehlercode zurueckgeben                                       *
'*  - Andernfalls mit Hilfe eines Hilfszeigers (hier pShowNode) und einer Schleife be- *
'*    ginnend beim ersten Knoten dessen Inhalt mit Hilfe von GetValue in die Listbox   *
'*    schreiben.                                                                       *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - keine                                                                            *
'***************************************************************************************
Public Function ShowList(ListBox As Object) As Integer
    Dim pShowNode As clsNodeD
         
         
    Set pShowNode = m_pRoot
     
    ListBox.Clear
    If pShowNode Is Nothing Then
        ListBox.AddItem "Leer!"
        
        'Rueckgabewert = Fehler
        ShowList = 1
    Else
        While Not pShowNode Is Nothing
            ListBox.AddItem pShowNode.GetValue
            Set pShowNode = pShowNode.GetNext
        Wend
        
        'Rueckgabewert = kein Fehler
        ShowList = 0
    End If
End Function


'***************************************************************************************
'* Public Function RemoveNode() As Integer:                                            *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  Den Knoten auf welches der (Member-) Zeiger (m_pActuell) zeigt, aus der Liste ent- *
'*  fernen, und den Speicherplatz fuer diesen Knoten wieder freigeben.                 *
'*                                                                                     *
'* Uebergabeparameter:                                                                 *
'*  - keiner                                                                           *
'*                                                                                     *
'* Rueckgabewert:                                                                      *
'*  - Fehlercode:   0 ... kein Fehler                                                  *
'*                  1 ... Es ist kein Knoten vorhanden                                 *
'*                                                                                     *
'* Vorgehensweise:                                                                     *
'*  - Pruefen, ob ueberhaupt schon ein Eintrag existiert (m_pRoot > Nothing)           *
'*  - Ist kein Knoten vorhanden (m_pRoot = Nothing), den entsprechenden Fehlercode dem *
'*    aufrufendem Programm zurueckgeben.                                               *
'*  - Ist zumindest ein Knoten vorhanden (m_pRoot > 0) den Knoten, auf den der         *
'*    Zeiger pActuell zeigt loeschen. Beim Entfernen (loeschen) eines Knotens muss     *
'*    zwischen 4 Faellen unterschieden werden:                                         *
'*                                                                                     *
'*      - FALL 1: Die gesamte Liste besteht nur aus einem einzigen Knoten. Dieser      *
'*        Knoten soll nun geloescht werden.                                            *
'*        Kennzeichen: m_pActuell.GetLast = Nothing                                    *
'*                     m_pActuell.GetNext = Nothing                                    *
'*          - Die (Member-)Zeiger m_pRoot, m_pEnd und m_pActuell mit Nothing laden, da *
'*            die Liste nun wieder leer ist. Dadurch wird der einzige zu loeschende    *
'*            Knoten aus dem Speicher geloescht.                                       *
'*                                                                                     *
'*      - FALL 2: Die Liste besteht aus mehreren Knoten, davon wird der erste Knoten   *
'*        geloescht.                                                                   *
'*        Kennzeichen: m_pActuell.GetLast = Nothing                                    *
'*                     m_pActuell.GetNext ungleich Nothing                             *
'*          - Den (Member-)Zeiger m_pActuell auf den auf m_pActuell folgenden Knoten   *
'*            setzen.                                                                  *
'*          - Den Zeiger auf den vor dem aktuellen Knoten (m_pActuell) zeigenden mit 0 *
'*            (Nothing) laden.                                                         *
'*          - Den (Member-)Zeiger m_pRoot mit m_pActuell laden, da die Liste nun einen *
'*            neuen Beginn (Wurzel) besitzt.                                           *
'*          - Es zeigt keine Referenz mehr auf den ersten Knoten der Liste. Dieser     *
'*            Knoten wird daher von Visual Basic automatisch vom Speicher entfernt.    *
'*                                                                                     *
'*      - FALL 3: Die Liste besteht aus mehreren Knoten, davon wird der letzte Knoten  *
'*        geloescht.                                                                   *
'*        Kennzeichen: m_pActuell.GetLast ungleich Nothing                             *
'*                     m_pActuell.GetNext = Nothing                                    *
'*          - Den (Member-)Zeiger m_pActuell auf den von m_pActuell vorhergehenden     *
'*            Knoten setzen.                                                           *
'*          - Den vom aktuellen Knoten (m_pActuell) aus auf den naechsten Knoten       *
'*            zeigenden Zeiger mit 0 (Nothing) laden, da es keinen nachfolgenen Knoten *
'*            gibt, bzw. der aktuelle Knoten auch gleichzeitig der letzte Knoten ist.  *
'*          - Den (Member-)Zeiger m_pEnd mit m_pActuell laden, da die Liste nun ein    *
'*            neues Ende besitzt.                                                      *
'*          - Es zeigt keine Referenz mehr auf den letzten Knoten der Liste. Dieser    *
'*            Knoten wird daher von Visual Basic automatisch vom Speicher entfernt.    *
'*                                                                                     *
'*      - FALL 4: Die Liste besteht aus mehreren Knoten, davon wird weder der erste    *
'*        Knoten noch der letzte Knoten geloescht. Sondern ein Knoten irgendwo         *
'*        zwischen Ersten und Letztem.                                                 *
'*        Kennzeichen: m_pActuell.GetLastEntry ungleich Nothing                        *
'*                     m_pActuell.GetNextEntry ungleich Nothing                        *
'*          - Die Adresse des auf m_pActuell folgenden Knotens in pTempNach sichern,   *
'*            und den zu m_pActuell vorherigen Eintrag in pTempVor sichern.            *
'*          - Alle Zeiger, die vom zu entfernenden Knoten weggehen ebenfalls loeschen  *
'*          - Die Knoten pTempVor und pTempNach miteinander verketten.                 *
'*          - Den (Member-)Zeiger m_pActuell mit pTempVor laden                        *
'*          - Es zeigt keine Referenz mehr auf den letzten Knoten der Liste. Dieser    *
'*            Knoten wird daher von Visual Basic automatisch vom Speicher entfernt.    *
'*                                                                                     *
'* Anmerkung zum Entfernen von referenzierten Objekten:                                *
'*    Visual Basic entfernt automatisch allozierte Objekte, wenn keine Referenz auf    *
'*    dieses Objekt zeigt. Anders ausgedrueckt: Wenn alle Referenzen auf ein dynamisch *
'*    erzeugtes Objekt den Wert Nothing beinhalten, entfernt Visual Basic automatisch  *
'*    dieses Objekt und gibt den Speicher wieder frei.                                 *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pEnd                                                                           *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Public Function RemoveNode() As Integer
    Dim pTempVor As clsNodeD
    Dim pTempNach As clsNodeD


    Set pTempVor = New clsNodeD     'Fuer Fall 4 (das zu loeschende Entry befindet sich
    Set pTempNach = New clsNodeD    'in der Mitte der Liste)

    If m_pRoot Is Nothing Then
     
        'Wenn kein Knoten vorhanden ist (m_pRoot = Nothing)
        RemoveNode = 1 ' Rueckgabewert: Fehler
    Else
        If m_pActuell.GetLast Is Nothing Then
            If m_pActuell.GetNext Is Nothing Then
                'Fall 1: Die Liste besteht nur aus einem einzigen Knoten
                'Dieser Knoten wird nun geloescht, der Speicherplatz fuer
                'diesen Knoten wird wieder freigegeben und die Zeiger m_pRoot,
                'm_pActuell und m_pEnd werden geloescht
                Set m_pRoot = Nothing
                Set m_pActuell = Nothing
                Set m_pEnd = Nothing
            Else
                'Fall 2: Die Liste besteht aus mehreren Knoten.
                'Der erste Knoten wird nun geloescht, und der Speicherplatz fuer
                'dieses Knoten wird wieder freigegeben

                'Zeiger m_pActuell auf den naechsten Knoten setzen
                Set m_pActuell = m_pActuell.GetNext

                'Den Zeiger m_pActuell.SetLast mit Nothing laden, da ja nun
                'dieser Knoten das erste Entry der Liste ist
                Set m_pActuell.SetLast = Nothing

                'Den Zeiger m_pRoot mit m_pActuell laden, da die Liste nun einen
                'neuen Beginn (Wurzel) besitzt
                Set m_pRoot = m_pActuell
                
                'Es zeigt keine Referenz mehr auf den ersten Knoten der Liste. Dieser
                'Knoten wird daher von Visual Basic automatisch vom Speicher entfernt.
            End If
        Else
            If m_pActuell.GetNext Is Nothing Then
                'Fall 3: Die Liste besteht aus mehreren Knoten.
                'Der letzte Knoten wird nun geloescht, und der Speicherplatz
                'fuer diesen Knoten wird wieder freigegeben

                'Zeiger m_pActuell auf den vorherige Knoten setzen
                Set m_pActuell = m_pActuell.GetLast

                'Den Zeiger m_pActuell->SetNext mit NULL laden, da ja nun
                'dieser Knoten der letzte Knoten der Liste ist.
                Set m_pActuell.SetNext = Nothing

                'Den Zeiger m_pEnd mit m_pActuell laden, da die Liste nun
                'ein neues Ende besitzt
                Set m_pEnd = m_pActuell
                
                'Es zeigt keine Referenz mehr auf den letzten Knoten der Liste. Dieser
                'Knoten wird daher von Visual Basic automatisch vom Speicher entfernt.
            Else
                'Fall 4: Die Liste besteht aus mehreren Knoten.
                'Es wird weder der erste noch der letzte Knoten geloescht,
                'sondern ein Knoten irgendwo in der Mitte der Liste, der
                'Speicherplatz fuer diesen Knoten wird wieder freigegeben.

                'Die Adresse des vorhergehenden Knotens in pTempVor sichern,
                'und die Adresse des naechsten Knotens in pTempNach sichern.
                '(Anm.: Bezueglich m_pActuell)
                Set pTempVor = m_pActuell.GetLast
                Set pTempNach = m_pActuell.GetNext

                'Alle Zeiger, die vom zu entfernenden Knoten weggehen ebenfalls
                'loeschen
                Set m_pActuell.SetLast = Nothing
                Set m_pActuell.SetNext = Nothing

                'Die Knoten pTempVor und pTempNach verketten
                Set pTempVor.SetNext = pTempNach
                Set pTempNach.SetLast = pTempVor

                'Den Zeiger m_pActuell mit pTempVor laden
                Set m_pActuell = pTempVor
                
                'Es zeigt keine Referenz mehr auf den ersten Knoten der Liste. Dieser
                'Knoten wird daher von Visual Basic automatisch vom Speicher entfernt.
            End If
        End If
    
        RemoveNode = 0 'Rueckgabewert: alles okay
    End If
End Function


'***************************************************************************************
'* Public Function RemoveList() As Integer:                                            *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  - Die gesamte Liste vom Speicher entfernen                                         *
'*                                                                                     *
'* Uebergabeparameter:                                                                 *
'*  - keiner                                                                           *
'*                                                                                     *
'* Rueckgabewert:                                                                      *
'*  - Fehlercode:   0 ... kein Fehler                                                  *
'*                  1 ... Es ist keine Liste vorhanden                                 *
'*                                                                                     *
'* Vorgehensweise:                                                                     *
'*  - Ist die Liste leer (m_pRoot = Nothing) muss sie auch nicht geloescht werden!! -  *
'*    Was nicht vorhanden ist, kann auch nicht geloescht werden!!                      *
'*  - Andernfalls mit Hilfe zweier Hilfszeiger (hier pRemoveNode und pRemoveNext)      *
'*    beginnend beim ersten Knoten diesen mit Hilfe einer Schleife Knoten fuer Knoten  *
'*    vom Speicher entfernen. Dabei zeigt der Zeiger pRemoveNode immer auf den zu ent- *
'*    fernenden Knoten und der Zeiger pRemoveNext auf den darauf folgenden Knoten.     *
'*    Dieser Vorgang wird solange fortgesetzt, bis pRemoveNext ein "Null-Zeiger" ist,  *
'*    D.h. der Zeiger den Wert Nothing beinhaltet. Denn dann ist er am Ende der Liste  *
'*    angekommen.                                                                      *
'*                                                                                     *
'* Anmerkung zum Entfernen von referenzierten Objekten:                                *
'*    Visual Basic entfernt automatisch allozierte Objekte, wenn keine Referenz auf    *
'*    dieses Objekt zeigt. Anders ausgedrueckt: Wenn alle Referenzen auf ein dynamisch *
'*    erzeugtes Objekt den Wert Nothing beinhalten, entfernt Visual Basic automatisch  *
'*    dieses Objekt und gibt den Speicher wieder frei.                                 *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pEnd                                                                           *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Public Function RemoveList() As Integer
    Dim pRemoveNode As clsNodeD
    Dim pRemoveNext As clsNodeD
   

    'Liste nur dann loeschen, wenn eine vorhanden ist!
    If m_pRoot Is Nothing Then
         'Wenn keine Liste vorhanden ist (m_pRoot = nothing)
        RemoveList = 1 ' Rueckgabewert: Fehler
    Else
        'Zeiger pRemoveNode auf den ersten Knoten setzen
        Set pRemoveNode = m_pRoot
        
        'alle moeglichen Referenzen auf den ersten Knoten loeschen
        Set m_pRoot = Nothing
        Set m_pEnd = Nothing
        Set m_pActuell = Nothing
         
        'Mit einer Schleife alle Knoten loeschen
        Do
            'Zeiger pRemoveNext auf den naechsten Knoten setzen
             Set pRemoveNext = pRemoveNode.GetNext()
 
            'Auch den Zeiger, der vom zu loeschenden Knoten weggeht loeschen
            Set pRemoveNode.SetNext = Nothing
            
            'Und auch den Zeiger, der vom naechsten Knoten auf den zu loeschenden
            'zurueck zeigt loeschen, wenn es noch einen naechsten Knoten gibt
            If Not pRemoveNode.GetNext Is Nothing Then
                Set pRemoveNext.SetLast = Nothing
            End If
            
            'Knoten auf den der Zeiger pRemoveNode zeigt loeschen
            Set pRemoveNode = Nothing

            'Zeiger pRemoveNode auf den naechsten Knoten setzen
            Set pRemoveNode = pRemoveNext
        Loop Until pRemoveNode Is Nothing
        
        'Rueckgabewert = Liste erfolgreich geloescht (kein Fehler)
        RemoveList = 0
    End If
End Function
 
 
 

