VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsLinkedListE"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'***************************************************************************************
'* Klasse clsLinkedListE        (clsLinkedListE.cls)                                   *
'*                                                                                     *
'* Kurzbeschreibung                                                                    *
'*  Klasse fuer eine einfach verkettete Liste (engl. linked list)                      *
'*                                                                                     *
'* Aenderungen/Ergaenzungen                                                            *
'*                                                                                     *
'* Entwickler: Buchgeher Stefan                                                        *
'* Entwicklungsbeginn dieser Klasse: 23. Februar 2007                                  *
'* Funktionsfaehig seit: 23. Februar 2007                                              *
'* Letzte Bearbeitung: 5. Maerz 2007                                                   *
'***************************************************************************************
Option Explicit


'****************** Member-Variablen ***************************************************
Private m_pRoot As clsNodeE      'Zeiger auf den ersten Knoten der Liste
Private m_pActuell As clsNodeE   'Zeiger auf den aktuellen Knoten der Liste

 
'****************** Member-Funktionen **************************************************
'Public Function AddNode(ByVal sValue As String) As Integer
'Public Function ShowList(ListBox As Object) As Integer
'Public Function RemoveList() As Integer


'****************** Konstruktor ********************************************************

'***************************************************************************************
'* Private Sub Class_Initialize():                                                     *
'*                                                                                     *
'* Aufgaben:                                                                           *
'*  - Die Member-Variablen mit 0 (= Nothing) initialisieren                            *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Private Sub Class_Initialize()
    Set m_pRoot = Nothing
    Set m_pActuell = Nothing
End Sub


'****************** Destruktor *********************************************************

'***************************************************************************************
'* Private Sub Class_Terminate():                                                      *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  Die gesamte Liste (falls vorhanden) vom Speicher entfernen.                        *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Private Sub Class_Terminate()
    Dim ErrorCode As Integer
    
    
    ErrorCode = RemoveList()
End Sub


'****************** Member-Funktionen (Realisierung) ***********************************

'***************************************************************************************
'* Public Function AddNode(sValue As String) As Integer:                               *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  Neuen Knoten (mit dem String sValue) ans Ende der bestehenden Liste anhaengen.     *
'*                                                                                     *
'* Uebergabeparameter:                                                                 *
'*  sValue: Dieser Wert (String) soll in den neu hinzugefuegten Knoten gespeichert     *
'*          werden.                                                                    *
'*                                                                                     *
'* Rueckgabewert:                                                                      *
'*  - Fehlercode:   0 ... kein Fehler                                                  *
'*                  1 ... Es kann kein Knoten hinzugefuegt werden, weil kein Speicher  *
'*                        alloziiert werden kann!                                      *
'*                                                                                     *
'* Vorgehensweise:                                                                     *
'*  - Speicherplatz fuer den neuen Knoten dynamisch anfordern.                         *
'*  - Die zu speichernden Daten im neuen Knoten (pNewNode) speichern (mit Hilfe der    *
'*    Memberfunktion SetValue der Klasse clsNode)                                      *
'*  - Das Verketten der Knoten ist nun abhaengig davon, an welcher Position sich der   *
'*    neue Knoten befindet:                                                            *
'*                                                                                     *
'*          - FALL 1: Es ist noch keine Liste Vorhanden, der "neue" Knoten ist daher   *
'*            der erste und befindet sich daher am Anfang der Liste.                   *
'*            (Kennzeichen: m_pRoot = 0 (NOTHING)                                      *
'*            Da es das erste Element der Liste ist gilt fuer diesen Knoten:           *
'*              - Der Zeiger auf den naechsten Knoten muss den Wert 0 (NOTHING)        *
'*                beinhalten (pNewNode.SetNext = NOTHING)                              *
'*              - Die (Member-)Zeiger m_pRoot und m_pActuell zeigen auf diesen ersten  *
'*                Knoten                                                               *
'*                                                                                     *
'*          - FALL 2: Es ist schon eine Liste vorhanden, der neue Knoten (pNewNode)    *
'*            wird an das Ende der Liste angehngt. Der Member-Zeiger m_pActuell zeigt *
'*            hier immer das Ende der Liste an.                                        *
'*            (Kennzeichen: m_pRoot > 0                                                *
'*            Da es der letzte Knoten der Liste ist gilt fuer diesen Knoten:           *
'*              - Der Zeiger von pNewNode auf den naechsten Knoten muss den Wert 0     *
'*                (NOTHING) beinhalten (pNewNode.SetNext = NOTHING)                    *
'*              - Der Zeiger von pActuell auf den naechste Knoten muss den Wert des    *
'*                Zeigers pNewNode beinhalten (m_pActuell.SetNext = pNewNode           *
'*              - Der (Member-)Zeiger m_pActuell zeigt auf diesen letzten Knoten.      *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Public Function AddNode(sValue As String) As Integer
    Dim pNewNode As clsNodeE
    
    
    'Knoten erzeugen
    Set pNewNode = New clsNodeE
     
    'Daten im  Knoten speichern
    pNewNode.SetValue = sValue
    
    Set pNewNode.SetNext = Nothing
    
    If m_pRoot Is Nothing Then
        'Fall 1: Erster Knoten der Liste
        'Set pNewNode.SetNext = Nothing
        Set m_pRoot = pNewNode
    Else
        'Fall 2: neuen (weiteren) Knoten an das Ende der Liste anhaengen
        'Set pNewNode.SetNext = Nothing
        Set m_pActuell.SetNext = pNewNode
    End If
    
    Set m_pActuell = pNewNode
    
    'Rueckgabewert
    AddNode = 0     'kein Fehler
End Function
 

'***************************************************************************************
'* Public Function ShowList(ListBox As Object) As Integer:                             *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  - Die gesamte Liste in der uebergebenen List-Box anzeigen                          *
'*                                                                                     *
'* Uebergabeparameter:                                                                 *
'*  - Listbox (Objekt)                                                                 *
'*                                                                                     *
'* Rueckgabewert:                                                                      *
'*  - Fehlercode:   0 ... kein Fehler                                                  *
'*                  1 ... Es ist keine Liste vorhanden                                 *
'*                                                                                     *
'* Vorgehensweise:                                                                     *
'*  - ListBox loeschen                                                                 *
'*  - Ist die Liste leer (m_pRoot = Nothing) den Text "Leer!" in die Listbox schreiben *
'*    und den entsprechenden Fehlercode zurueckgeben.                                  *
'*  - Andernfalls mit Hilfe eines Hilfszeigers (hier pShowNode) und einer Schleife be- *
'*    ginnend beim ersten Knoten dessen Inhalt mit Hilfe von GetValue in die Listbox   *
'*    schreiben.                                                                       *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - keine                                                                            *
'***************************************************************************************
Public Function ShowList(ListBox As Object) As Integer
    Dim pShowNode As clsNodeE
         
         
    Set pShowNode = m_pRoot
     
    ListBox.Clear
    If pShowNode Is Nothing Then
        ListBox.AddItem "Leer!"
        
        'Rueckgabewert = Fehler
        ShowList = 1
    Else
        While Not pShowNode Is Nothing
            ListBox.AddItem pShowNode.GetValue
            Set pShowNode = pShowNode.GetNext
        Wend
        
        'Rueckgabewert = kein Fehler
        ShowList = 0
    End If
End Function


'***************************************************************************************
'* Public Function RemoveList() As Integer:                                            *
'*                                                                                     *
'* Aufgabe:                                                                            *
'*  - Die gesamte Liste vom Speicher entfernen                                         *
'*                                                                                     *
'* Uebergabeparameter:                                                                 *
'*  - keiner                                                                           *
'*                                                                                     *
'* Rueckgabewert:                                                                      *
'*  - Fehlercode:   0 ... kein Fehler                                                  *
'*                  1 ... Es ist keine Liste vorhanden                                 *
'*                                                                                     *
'* Vorgehensweise:                                                                     *
'*  - Ist die Liste leer (m_pRoot = Nothing) muss sie auch nicht geloescht werden!! -  *
'*    Was nicht vorhanden ist, kann auch nicht geloescht werden!!                      *
'*  - Andernfalls mit Hilfe zweier Hilfszeiger (hier pRemoveNode und pRemoveNext)      *
'*    beginnend beim ersten Knoten diesen mit Hilfe einer Schleife Knoten fuer Knoten  *
'*    vom Speicher entfernen. Dabei zeigt der Zeiger pRemoveNode immer auf den zu ent- *
'*    fernenden Knoten und der Zeiger pRemoveNext auf den darauf folgenden Knoten.     *
'*    Dieser Vorgang wird solange fortgesetzt, bis pRemoveNext ein "Null-Zeiger" ist,  *
'*    D.h. der Zeiger den Wert Nothing beinhaltet. Denn dann ist er am Ende der Liste  *
'*    angekommen.                                                                      *
'*                                                                                     *
'* Anmerkung zum Entfernen von referenzierten Objekten:                                *
'*    Visual Basic entfernt automatisch allozierte Objekte, wenn keine Referenz auf    *
'*    dieses Objekt zeigt. Anders ausgedrueckt: Wenn alle Referenzen auf ein dynamisch *
'*    erzeugtes Objekt den Wert Nothing beinhalten, entfernt Visual Basic automatisch  *
'*    dieses Objekt und gibt den Speicher wieder frei.                                 *
'*                                                                                     *
'* Veraenderte Member-Variablen:                                                       *
'*  - m_pRoot                                                                          *
'*  - m_pActuell                                                                       *
'***************************************************************************************
Public Function RemoveList() As Integer
    Dim pRemoveNode As clsNodeE
    Dim pRemoveNext As clsNodeE
   

    'Liste nur dann loeschen, wenn eine vorhanden ist!
    If m_pRoot Is Nothing Then
         'Wenn keine Liste vorhanden ist (m_pRoot = nothing)
        RemoveList = 1 ' Rueckgabewert: Fehler
    Else
        'Zeiger pRemoveNode auf den ersten Knoten setzen
        Set pRemoveNode = m_pRoot
        
        'alle moeglichen Referenzen auf den ersten Knoten loeschen
        Set m_pRoot = Nothing
        Set m_pActuell = Nothing
         
        'Mit einer Schleife alle Knoten loeschen
        Do
            'Zeiger pRemoveNext auf den naechsten Knoten setzen
             Set pRemoveNext = pRemoveNode.GetNext()
 
            'Auch den Zeiger, der vom zu loeschenden Knoten weggeht loeschen
            Set pRemoveNode.SetNext = Nothing
            
            'Knoten auf den der Zeiger pRemoveNode zeigt loeschen
            Set pRemoveNode = Nothing

            'Zeiger pRemoveNode auf den naechsten Knoten setzen
            Set pRemoveNode = pRemoveNext
        Loop Until pRemoveNode Is Nothing
        
        'Rueckgabewert = Liste erfolgreich geloescht (kein Fehler)
        RemoveList = 0
    End If
End Function
 
 
 
 

